var _wulixuedacidianAug07 = {
  layTexts: function () {
    var _wulixuedacidianAug07Doc = document.querySelector('div.wulixuedacidian-aug-07');

    // create a dummy element to help calculate width
    var dummy = document.createElement('div')
    dummy.style.display = 'none'
    dummy.style.width = '2500px'

    // clear all existing texts
    var existingTextLayers = _wulixuedacidianAug07Doc.querySelectorAll(".text-layer")
    if (existingTextLayers.length != 0) {
      for (var i = 0; i < existingTextLayers.length; i++) {
        _wulixuedacidianAug07Doc.querySelector('.svg-image').removeChild(existingTextLayers[i])
      }
    }

    // 500 px -> 16 px
    var texts = _wulixuedacidianAug07Doc.querySelectorAll(".wulixuedacidian-aug-07 span.text");
    var target = _wulixuedacidianAug07Doc.querySelector(".wulixuedacidian-aug-07 .svg-image");

    var curSvgWidth = target.getElementsByTagName('img')[0].clientWidth;
    var fontSize = curSvgWidth / 500 * 16
    target.style.fontSize = fontSize + 'px';
    var ratio = curSvgWidth / 249;

    for (var i = 0; i < texts.length; i++) {
      var text = texts[i];
      var tempSpan = document.createElement('span')
      tempSpan.classList.add("text-layer")
      tempSpan.style.position = "absolute"
      tempSpan.style.top = (text.getAttribute("y2") - 1.8) * ratio + "px"
      tempSpan.style.left = text.getAttribute("x1") * ratio + 'px'
      tempSpan.innerHTML = text.innerHTML
      tempSpan.style.width = '2000px'
      target.appendChild(tempSpan)

      var targetWidth = (text.getAttribute("x2") - text.getAttribute("x1")) * ratio
      var tempSmallSpans = tempSpan.querySelectorAll('span')
      var realWidth = (tempSmallSpans[tempSmallSpans.length - 1].offsetLeft + tempSmallSpans[tempSmallSpans.length - 1].offsetWidth)
      // calculate needed margin, add margin for every span inside
      var targetMargin = 0;
      if (realWidth > targetWidth + 5) {
        targetMargin = (Math.ceil(realWidth / targetWidth) * targetWidth - realWidth) / (tempSmallSpans.length) + 'px';
        targetWidth += 10
        tempSpan.style.lineHeight = fontSize * 1.65 + 'px'
      } else {
        targetMargin = (targetWidth - realWidth) / (tempSmallSpans.length) + 'px';
        targetWidth += 4
      }
      for (var j = 0; j < tempSmallSpans.length - 1; j++) {
        tempSmallSpans[j].style.marginRight = targetMargin
      }

      tempSpan.style.width = targetWidth + 'px';
    }
  },
  debounce: function (func) {
    var timer;
    return function (event) {
      if (timer) clearTimeout(timer);
      timer = setTimeout(func, 200, event);
    };
  }
}


window.addEventListener('load', function () {
  _wulixuedacidianAug07.layTexts();
})

window.addEventListener('resize', _wulixuedacidianAug07.debounce(_wulixuedacidianAug07.layTexts))